Subject: Re: [bitcoindev] RBFR makes the CPFP carve-out obsolete with cluster mempool, without upgrading LN nodes; TRUC/V3 does not

From: "David A. Harding" <[email-masked]>
Date: Mon, 22 Jul 2024 12:08:28 -1000

On 2024-07-22 10:06, Peter Todd wrote:
> can [you] point to actual "significant discussion and analysis"
> of the idea

The idea for imbued TRUC was developed in part during a live
discussion with LN maintainers:
https://btctranscripts.com/lightning-specification/lightning-2024-01-15-specification-call/

I'm aware of three discussions about it on the Delving Bitcoin Forum:

- 
https://delvingbitcoin.org/t/lightning-transactions-with-v3-and-ephemeral-anchors/418/2
- 
https://delvingbitcoin.org/t/sibling-eviction-for-v3-transactions/472#benefits-1
- (as previously linked) 
https://delvingbitcoin.org/t/analysis-of-attempting-to-imbue-ln-commitment-transaction-spends-with-v3-semantics/527

Each of those discussions was summarized by a Bitcoin Optech Newsletter,
a publication read by many Bitcoin and LN protocol developers
(disclosure: I co-author the newsletter):

   "Adding this policy and automatically applying it to current LN 
anchors
   will allow the CPFP carve-out rule to be removed, which is necessary 
for
   cluster mempool to be implemented, which should allow making
   replacements of all kinds more incentive-compatible in the future."

https://bitcoinops.org/en/newsletters/2024/01/31/#kindred-replace-by-fee

   "Imbued v3 logic: In response to concerns voiced in the LN spec 
meeting
   that it may take a long time for LN to design, implement, and deploy
   these changes, Gregory Sanders proposed an intermediate stage with
   temporary special treatment of transactions that look like current
   anchors-style LN commitment transactions, allowing Bitcoin Core to
   deploy cluster mempool without being blocked by LN development."

   https://bitcoinops.org/en/newsletters/2024/01/24/#imbued-v3-logic

   "[...] research into the idea of automatically applying v3 transaction
   relay policy to anchors-style LN commitment and fee-bumping 
transactions
   (see Newsletter #286 for the underlying imbued v3 proposal)."

https://bitcoinops.org/en/newsletters/2024/02/14/#what-would-have-happened-if-v3-semantics-had-been-applied-to-anchor-outputs-a-year-ago

The word "imbue" is mentioned in 7 separate posts by 4 separate authors
in a Bitcoin Core discussion issue that includes comments from three
different LN implementation maintainers plus @petertodd, who I assumed
was you: https://github.com/bitcoin/bitcoin/issues/29319

That thread also links to a draft implementation of imbued v3, which was
used for the Analysis forum post:
https://github.com/bitcoin/bitcoin/pull/29427

As discussed in the "sibling eviction" thread (summarized in the
2024-01-31 newsletter), one of the necessary parts for imbued TRUC to be
effective at replacing CPFP-CO is sibling eviction.  A version of that
(currently only for opt-in TRUC) was merged into Bitcoin Core several 
months
ago: https://github.com/bitcoin/bitcoin/pull/29306

I note that none of the above was hidden or hard to find.  All three of
the discussion summaries quoted above are linked on the Bitcoin Optech
topic page about v3 relay/TRUC, and two of them are also linked on the
topic pages about CPFP-CO and anchor outputs.  Most of the other stuff I
found by searching the bitcoin/bitcoin repository for the word "imbue":

- https://bitcoinops.org/en/topics/version-3-transaction-relay/
- https://bitcoinops.org/en/topics/cpfp-carve-out/
- https://bitcoinops.org/en/topics/anchor-outputs/

> Frankly, unless you can point to actual "significant discussion and 
> analysis"
> of the idea, it's dishonest and toxic of you to portray it as such as 
> you
> should know better.

I'm sorry you've been unable to keep up with protocol development and
are confusing that for me being dishonest and toxic.  May I suggest you
subscribe to the weekly Optech newsletter?  It's free.

-Dave

-- 
You received this message because you are subscribed to the Google Groups "Bitcoin Development Mailing List" group.
To unsubscribe from this group and stop receiving emails from it, send an email to [email-masked].
To view this discussion on the web visit https://groups.google.com/d/msgid/bitcoindev/6c222c758e10e8061ccdcc180b1826a3%40dtrt.org.